#ifndef ERRORS_H_
#define ERRORS_H_

#include "project.def"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#ifndef _char
# define _char char
#endif

#define CE_REDIRECTED  0x8000
#define CE_SENDDATA    0x4000
#define CE_RENEGOTIATE 0x2000

extern _char erlst[][32];

/* Error Number Definitions*/
#define illegal_line               1
#define illegal_format             2
#define illegal_arithmetic         3
#define ambiguous                  4
#define illegal_delimiter          5
#define zero_divide                6
#define WA_full                    7
#define non_existent               8
#define wrong_type                 9
#define link_exhausted             10

#define not_properly               11
#define un_allocated               12
#define no_such_line               13
#define illegal_data_size          14
#define if_error                   15
#define escape_typed               16
#define ask_error                  18
#define hardware_busy              19
#define argument_list_error        20

#define file_error                 21
#define use_stream_transport       22
#define dimension_error            23
#define square_root_negative       24
#define buffer_too_small           25
#define string_too_long            26
#define ipx_socket_error           27
#define net_read_error             28
#define not_ready                  29
#define invalid_transport_size     30

#define log_negative               31       /* or = 0 */
#define device_not_connected       32
#define unauthorised_action        33
#define hardware_error             34
#define illegal_equipment_number   35
#define illegal_property           36
#define out_of_range               37
#define not_implemented            38
#define no_such_computer           39
#define string_filled              40

#define syntax_error               41
#define no_such_file               42
#define file_already_exists        43
#define no_file_space              44
#define link_not_open              45
#define remitted_data_lost         46
#define end_of_file                47
#define archive_busy               48
#define server_name_in_use         49
#define no_such_column             50

#define out_of_client_memory       51
#define def_area_full              52
#define def_syntax                 53
#define illegal_string_set         54
#define serr1                      54
#define string_function_failure    55
#define serr2                      55
#define Sif_error                  57       /* SERR4 on NORD */
#define Sask_error                 58       /* SERR5 */
#define string_expected            59       /* SERR6 */
#define out_of_local_memory        60

#define out_of_shared_memory       61
#define invalid_structure_tag      62
#define invalid_index              63
#define illegal_equipment_name     64
#define link_error                 65
#define code_failure               66
#define bracket_missing            67
#define wrong_hexa                 68
#define wrong_octal                69
#define illegal_character          70

#define illegal_operator           71
#define not_allowed                72
#define illegal_read_write         73
#define out_of_server_memory       74
#define database_not_loaded        75
#define illegal_command            76
#define resources_exhausted        77
#define file_not_open              78
#define sedac_error                79    /*sedac*/
#define no_such_loop               80    /*serial sedac*/

#define semaphore_error            81
#define driver_not_installed       82
#define port_not_available         83
#define scan_error                 84    /*scanner*/
#define semaphore_busy             85
#define non_existent_elem          86
#define non_existent_fec           87
#define non_existent_client        88
#define cannot_lock                89
#define not_running                90

#define not_posted                 91
#define not_accepted               92
#define operation_timeout          93
#define illegal_protocol           94
#define gpib_error                 95
#define rs232_error                96
#define operation_busy             97
#define connection_timeout         98
#define illegal_mode               99
#define not_owner                 100

#define not_defined               101
#define net_write_error           102
#define invalid_data              103
#define software_error            104
#define access_denied             105
#define tcp_not_supported         106
#define ipx_not_supported	        107
#define host_not_resolved	        108
#define tcp_connect_error	        109
#define tcp_socket_error 	        110

#define fpss_error       	        111
#define fpss_timeout     	        112
#define fpss_overflow    	        113
#define link_exists      	        114

#define max_alarms_exceeded       115
#define not_exported              116
#define is_switching              117
#define at_limit                  118
#define get_subscription_id       119
#define renegotiate_contract      120
#define server_redirection        121
#define value_too_high            122
#define value_too_low             123
#define warn_too_high             124
#define warn_too_low              125

#define completion_waiting        126
#define cannot_select             127
#define has_query_function        128
#define not_signalled             129
#define call_redirection          130
#define udp_socket_error 	        131
#define mutex_error               132
#define data_not_local            133

extern int numErr;

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* ERRORS_H_ */
