/** \file srvip.h
 *
 * server-side (and client-side) structs, macros, prototypes, etc.
 *
 */
#ifndef SRVIP_H_
#define SRVIP_H_

#include "project.def"

#include "servdef.h"

#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#if defined(MSDOS) /* MSDOS */
#include <sys/socket.h>
#elif defined(UNIX) /* UNIX */
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/un.h>
#include <stddef.h>
#include "unixcmd.h"
extern int BroadcastServer;
extern char gIpcTinePipe[64];
extern int nipcconsumers;
#elif defined(NIOS) /* NIOS */
#include "socket.h"
#endif 
extern int gUseLoopback;

#ifndef NumTCPChan
# define NumTCPChan	  5
#endif
#ifndef UDP_PORT
# define UDP_PORT       9003
#endif
extern int gtUDPPort;
#define TCP_LEGACYPORT  8003
#ifndef TCP_PORT
# define TCP_PORT       8503
#endif
extern int gtTCPPort;
#ifndef GCAST_PORT
# define GCAST_PORT     8004
#endif
extern int gtGCastPort;
#ifndef NETSRV_PORT
# define NETSRV_PORT     9002
#endif
extern int gtNetSrvPort;
#ifndef MCAST_PORT
# define MCAST_PORT     9503
#endif
extern int gtMCastPort;
#ifndef UDP_CLN_PORT
# define UDP_CLN_PORT   8050
#endif
extern int gtUDPClnPort;
#ifndef UDP_CLN_RANGE
# define UDP_CLN_RANGE (UDP_CLN_PORT+1000)
#endif
#ifndef NETBCST_ADDR
# define NETBCST_ADDR "0.0.0.0"
#endif
extern char *gtNetLclBcast;
#ifndef NETSRV_ADDR
# define NETSRV_ADDR "238.1.1.2"
#endif
extern char *gtNetSrvAddr;
#ifndef MCAST_ADDR
# define MCAST_ADDR "238.1.1.1"
#endif
extern char *gtMCastAddr;
#ifndef GCAST_ADDR
# define GCAST_ADDR "238.1.1.0"
#endif
extern char *gtGCastAddr;
#ifndef MCAST_TTL
# define MCAST_TTL 16
#endif
extern int gtMCastTTL;
#ifndef CLN_PATH
# define CLN_PATH "/var/tmp/"
#endif
#define CLN_PERM S_IRWXU
#ifndef IPC_PATH
# define IPC_PATH "/tmp/"
#endif
#define IPC_PERM S_IRWXU

#ifndef MAX_TCPCONNECTIONS
# define MAX_TCPCONNECTIONS 32
#endif

#define MIN_FDSETS 16

#ifndef DEFAULT_TCP_CONNECTION_TIMEOUT
# define DEFAULT_TCP_CONNECTION_TIMEOUT 200
#endif

#ifndef TIME_SERVER_HOST
# define TIME_SERVER_HOST NULL
#endif

#define LOOPBACKADDR "127.0.0.1"

#ifndef IPPORT_ECHO
# define IPPORT_ECHO 7
#endif

#define NETSRV_SOCKET 6565

typedef struct tcpIdleConnectionStruct
{
  int idx;
  int sck;
  int ttl;
  struct tcpIdleConnectionStruct *prv;
  struct tcpIdleConnectionStruct *nxt;
} IDLE_CONNECTION;
extern IDLE_CONNECTION *tcpIdleConnectionList;
IDLE_CONNECTION *getIdleConnection(int idx);
IDLE_CONNECTION *AddIdleConnection(int sck,int idx);
IDLE_CONNECTION *RemoveIdleConnection(IDLE_CONNECTION *ic);
IDLE_CONNECTION *getIdleConnectionBySocket(int sck);

typedef struct tcpbckt
{
  int idx;                  /* FEC index             */
  int sck;                  /* TCP connection socket */
  int ptr;                  /* bucket pointer        */
  int siz;                  /* bucket target size    */
  BYTE buf[UDP_BUFFER_SIZE];/* bucket buffer         */ 
  struct tcpbckt *nxt;      /* this is a linked list */
} TCPBCKT;
extern TCPBCKT *bcktList;
TCPBCKT *findBucket(int sck);
TCPBCKT *getBucket(int sck);
void freeBucket(int sck);

extern int *TCPsck;
extern int nTCPsck;
extern int maxFdSets;
extern int maxTCPConnections;

extern int IPXProducerSocket;
extern int IPXConsumerSocket;
extern int IPXMCastConsumerSocket;
extern int ipcProducerSocket;
#define soerr(s) {cc = udp_socket_error; strcat(txt,s); goto err;}

extern struct in_addr tMCastAddr;
extern struct in_addr tGCastAddr;
extern struct in_addr tNetSrvAddr;
extern struct sockaddr_in tMCastAddrSck;
extern struct sockaddr_in tGCastAddrSck;
extern struct sockaddr_in tNetSrvAddrSck;
extern fd_set ext_set;
extern int externalFdSets;
extern struct sockaddr_in *IPNetList;
extern int NrOfIPNets;
extern struct sockaddr_in *IPBcastList;
extern int NrOfIPBcastNets;
void FD_MERGE(fd_set fdsrc,fd_set *fddst);
extern void (*socketAcceptEntryFcn)(void);
void CloseConnectionSocket(int sck);
void closeIPConnectionToFec(int index);
int ListenForIPMulticasts(void);
int ListenForIPNetGlobals(void);
UINT32 getmyipaddr(void);
int getIPControlNets(char *fn,int *nr,struct sockaddr_in **list);
int appendRegisteredNetsList(char *fn,int *nr,struct sockaddr_in **list,char *ipaddr);
extern int ListenForGlobals;
#ifdef WINNT
int GetErrno(void);
int WinsockLoaded(void);
#endif
#ifdef UNIX
int isUnixSocket(int sck);
#define writeto(fd,bf,sz,fg,ad,ln) (\
  !isUnixSocket(fd) ? sendto(fd,bf,sz,fg,ad,ln) : write(fd,bf,sz)\
)
#define readfrom(fd,bf,sz,fg,ad,ln) (\
  !isUnixSocket(fd) ? recvfrom(fd,bf,sz,fg,ad,(int *)ln) : read(fd,bf,sz)\
)
#else
#define writeto(fd,bf,sz,fg,ad,ln) sendto(fd,bf,sz,fg,ad,ln)
#define readfrom(fd,bf,sz,fg,ad,ln) recvfrom(fd,bf,sz,fg,ad,ln)
#endif

#define ProcessData(sck,bf) {\
  if (IncomingNetworkProtocol == TCP || IncomingNetworkProtocol == PIPE) {\
    if ((bckt=findBucket(sck)) != NULL) {\
      nleft = nread;\
      while (nleft > 0) {\
        if (bckt->ptr == 0) bckt->siz = PeekWord(*(short *)(bf));\
        n = bckt->siz - bckt->ptr;\
        if (nleft >= n) {\
          memcpy(&bckt->buf[bckt->ptr],bf,n);\
          consumeData(bckt->buf);\
          bf += n;\
          nleft -= n;\
          bckt->ptr = 0;\
        } else {\
          memcpy(&bckt->buf[bckt->ptr],bf,nleft);\
          bckt->ptr += nleft;\
          nleft = 0;\
        }\
      }\
    }\
  } else {\
    consumeData(bf);\
  }\
}

#define recvIncomingIPData(sck) {\
  if (FD_ISSET(sck,&conset)) {\
    if ((nread=readfrom(sck,(char *)clnWorkArea,MIN_WORK_SIZE,0,(struct sockaddr *)&IncomingIPfec,&len)) > 0 &&\
        (n=PeekWord(*(short *)clnWorkArea)) > 0)\
    {\
      if (IncomingNetworkProtocol == TCP) {\
        len = sizeof(IncomingIPfec);\
        getpeername(sck,(struct sockaddr *)&IncomingIPfec,(int *)&len);\
        inet_ntoa_b(IncomingIPfec.sin_addr,fecaddr);\
      } else if (IncomingNetworkProtocol == PIPE) {\
        strncpy(fecaddr,"local pipe",16);\
      } else if (nread == n) {\
        inet_ntoa_b(IncomingIPfec.sin_addr,fecaddr);\
      }\
      bufptr = clnWorkArea; ProcessData(sck,bufptr);\
    } else {\
      if (IncomingNetworkProtocol == PIPE) {\
        close(sck); freeBucket(sck); sck = 0;\
      }\
    }\
    if (NGdebug > 3) {\
      if (nread <= 0) dbglog("%s: read error",fecprot);\
      else dbglog("%s: %d bytes read from %d",fecprot,nread,n);\
    }\
  }\
}

/**
 * \internal
 * \brief Calls listenUDP and adds the socket to a file descriptor set.
 * \todo why implemented as a macro?
 */
#define setupGlobalsSocket(sck,p) {\
  if (listenUDP(&(sck),p)) {\
    sck = 0;\
    feclog("cannot open %s socket",p == GCAST_PORT ? "GLOBALS" : "MCAST");\
  }\
  if (sck) FD_SET(sck,&conset);\
}

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* SRVIP_H_ */
