#ifndef THREADER_H_
#define THREADER_H_

#include "rpctypes.h"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#ifdef MULTITHREADED
typedef struct 
{
  void (*tsk)(void);
  int rate;
  void *ref;
} BkgThreadFcn;
extern int useMultiThreadedBackgroundTasks;
extern int useMultiThreadedEquipmentFunctions;
extern int hEqpFcnThread;
int bkgCreateThread(BkgThreadFcn *tsk);
#define EqpThreadMutexName "tineEqpThreadMutex"
#define thread_dbglog(txt) {\
    dbglog("[T1]: %s %s %s -> %s",\
    cl->contract.EqpName,cl->contract.EqpDeviceName,\
    cl->contract.EqpProperty,(txt));\
  }

#if defined(UNIX)

#define THREAD_TYPE void *
#define THREAD_PARAM void *
#include "pthread.h"
extern pthread_attr_t gBkgThreadAttr;
void *bkgTaskThread(void *lpvThreadParam);
void *eqpTaskThread(void *lpvThreadParam);
#define threadExit(t) pthread_cancel((pthread_t)t)
int WaitForMutex(pthread_mutex_t *mx,int to);
#define ReleaseMutex(mx) pthread_mutex_unlock(mx)
extern pthread_mutex_t *hEqpThreadMutex;

#elif defined(WINNT)

#define THREAD_TYPE DWORD WINAPI 
#define THREAD_PARAM LPVOID
extern DWORD dwBkgThreadId;
DWORD WINAPI bkgTaskThread(LPVOID lpvThreadParam);
DWORD WINAPI eqpTaskThread(LPVOID lpvThreadParam);
#define threadExit(t) TerminateThread((HANDLE)t,0)
#define bkgThreadResume(t) ResumeThread((HANDLE)t)
extern HANDLE hEqpThreadMutex;
#define WaitForMutex(mx,to) WaitForSingleObject(mx,(to) < 0 ? INFINITE : to)

#endif

#endif /* MULTITHREADED */

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* THREADER_H_ */
