#ifndef UNIXCMD_H_
#define UNIXCMD_H_

#include "project.def"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#include <sys/types.h>
#include <signal.h>

#ifndef CS_OPEN
# define CS_OPEN "/tmp/fecipc.srv"
#endif
#define CMDSIZE 256
#define MAXIPCCLIENTS  5
#ifdef SVR4
# define FIFO_MODE (S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP)
#endif

#define CMDSTRSIZE 80

typedef struct usrfcnStruct
{
  char name[32];
  int (*fcn)(int argc,char *argv[]);
  struct usrfcnStruct *next;
} USRFCN;
extern USRFCN *usrfcn;
extern int numUsrFcn;

typedef struct usrcmdStruct
{
  char cmd[32];
  int (*fcn)(int,int,int,int);
  int *iparam;
  float *fparam;
  int access;
  struct usrcmdStruct *next;
} USRCMD;
extern USRCMD *usrcmd;
extern int numUsrCmd;
int RegisterUserCommand(
    char *cmd,
    int (*fcn)(int,int,int,int),
    int *iparam,
    float *fparam,
    int access);

int getVal(char *var,char *s);
int setVal(char *var,char *val);
int InterpretCommand(char *cmd);
int quit(char *s1,char *s2);
int help(char *s1,char *s2);
int GetCommand(int fd,char *buf,int bufsiz);
int CMDlisten(const char *name);
int CMDaccept(int lsnfd, uid_t *uidptr);
int CMDconnect(const char *name);
int rmtoutput(char *str);
int ttyoutput(char *str);
void dumpGlobals(void);
void addIPCcln(void);
void sig_pipe(int signo);
#ifdef BSDSIGNAL
#  define bsdsignal(s,d) signal(s,d)
#else
Sigfunc *bsdsignal(int signo, Sigfunc *disp);
#endif
extern int NumCommands;
extern int NrOfEqpTypes;
extern int IPCfds[MAXIPCCLIENTS],IPCSocket;
extern int nipcclients;
extern int foreground;
extern int CommandLevel;
extern char CommandString[CMDSTRSIZE];

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* UNIXCMD_H_*/
