#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <dlfcn.h>
#include "extcode.h"

short tAttachNotifier(char *fullDeviceNameAndProperty, void (*nf)(int), int nid);
void tDetachNotifier(void (*nf)(int));

#define MAXNOTIFIERS 256
typedef struct NotifierTableStruct
{
  int index;
  LVRefNum lvOccurrence;
} NotifierTable;
NotifierTable notifiers[MAXNOTIFIERS];

int initNotifierTable(void)
{
  int i;
  for (i=0; i<MAXNOTIFIERS; i++) notifiers[i].index = -1;
  return 0;
}
int getNotifierIndex(void)
{
  int i;
  for (i=0; i<MAXNOTIFIERS; i++) 
  {
    if (notifiers[i].index == -1) 
    {
      notifiers[i].index = i;
      return i;
    }
  }
  return -1;
}
int freeNotifierIndex(int index)
{
  if (index <0 || index >= MAXNOTIFIERS) return -1;
  notifiers[index].index = -1;
  return 0;
}

LVRefNum gLvOccurrence;
int initialized = 0;

void lvTineNotifyCallback(int nid)
{
  if (initialized) 
  {
    Occur(notifiers[nid].lvOccurrence);
  }
}
short RegisterServerOccurrence(char *prpName,LVRefNum *refNum)
{
  int nid = getNotifierIndex();
  if (nid < 0) return -1;
  initialized = -1;
  notifiers[nid].lvOccurrence = *refNum;
  gLvOccurrence = *refNum;
  return RegisterServerNotifierEx(prpName,lvTineNotifyCallback,nid);
}
short RegisterClientOccurrence(char *fullDeviceNameAndProperty,LVRefNum *refNum)
{
  int nid = getNotifierIndex();
  if (nid < 0) return -1;
  initialized = -1;
  notifiers[nid].lvOccurrence = *refNum;
  return tAttachNotifier(fullDeviceNameAndProperty,lvTineNotifyCallback,nid);
}
__attribute__((constructor)) void TineStartNotifier(void)
{
  initNotifierTable();
}
__attribute__((destructor)) void TineStopNotifier(void)
{
  tDetachNotifier(lvTineNotifyCallback);
}

