#ifndef NIOSCMD_H_
#define NIOSCMD_H_

#include "project.def"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#include <signal.h>
#include <sys/types.h>
#include "rpcdefs.h"
#define CMDSIZE 256

typedef struct usrfcnStruct
{
  char name[32];
  int (*fcn)(int argc,char *argv[]);
  struct usrfcnStruct *next;
} USRFCN;
extern USRFCN *usrfcn;
extern int numUsrFcn;

typedef struct usrcmdStruct
{
  char cmd[32];
  int (*fcn)(int,int,int,int);
  int *iparam;
  float *fparam;
  int access;
  struct usrcmdStruct *next;
} USRCMD;
extern USRCMD *usrcmd;
extern int numUsrCmd;

int RegisterUserCommand(
    char *cmd,
    int (*fcn)(int,int,int,int),
    int *iparam,
    float *fparam,
    int access);

int getVal(char *var,char *s);
int setVal(char *var,char *val);
int InterpretCommand(char *cmd);
int quit(char *s1,char *s2);
int help(char *s1,char *s2);
void GetCommand(void);
int getControlSystemInfo(void);
void FecSynchronize(void);
void FecShowtime(void);
void initWatchDog(void);
int initSAPWatchDog(void);
void netWatchDog(void);
void watchDog(void);
void enableWatchDog(void);
void disableWatchDog(void);
int NetHandler(int errval,int ax,int bp,int si);
void dumpGlobals(void);
extern int NumCommands;
extern int NumEquipmentFunctions;
extern char cmdbuf[CMDSIZE];
extern char strbuf[CMDSIZE];
extern WORD watchdogBaseAddress;
extern int watchdogEnabled;
extern int CommandLevel;

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* NIOSCMD_H_*/
