#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <dir.h>
#include <conio.h>
#include <sys\timeb.h>
#include <nwipxspx.h>
#include <sys/socket.h>
#include "prolog.h"
#include "servdef.h"

extern int DiskErrorCount;  /* from syslib.c, incremented on disk IO errors */
int RebootOnConnectionFailure = 0;
char controlFS[48];
NodalError F_boot(void);
extern int TCPloaded;
#define iswap(i) ( ((i)>>8) | ((i)<<8) )
#define NUM_SAP_ECB 3

typedef struct
{
  ECB ecb;
  SAP sap;
} SAPECB;

#define initSAPECB(e,sock) {\
  (e)->ecb.ESRAddress=(void (far *)())NULL;\
  (e)->ecb.fragmentCount=1;\
  (e)->ecb.socketNumber=(sock);\
  (e)->ecb.fragmentDescriptor[0].address=&(e)->sap;\
  (e)->ecb.fragmentDescriptor[0].size=sizeof(SAP); }

#define FIVEMINUTES (5*60)
SAPECB *sapECB[NUM_SAP_ECB];
char password[48];
int fsAlive = 0;
time_t fsLastSAP = 0;
int SAPWatchDogInitialized = FALSE;
int initSAPWatchDog(void)
{
  int i,cc = 0;
  int sapsocket = iswap(SAP_SOCKET);
  char *c;

  if (!RebootOnConnectionFailure) return not_implemented;

  if ((c=getenv("FILE_SERVER")) != NULL) strncpy(controlFS,c,48);
  else return no_such_computer;

  if (IPXOpenSocket((BYTE *)&sapsocket,0)) return ipx_socket_error;

  for (i=0; i<NUM_SAP_ECB; i++)
  {
    if ((sapECB[i]=calloc(1,sizeof(SAPECB))) == NULL) return out_of_server_memory;
    initSAPECB(sapECB[i],sapsocket);
    IPXListenForPacket((ECB *)sapECB[i]);
  }
  fsAlive = 1;              /* assume the best ... */
  fsLastSAP = time(NULL);
  SAPWatchDogInitialized = TRUE;
  return cc;
}
unsigned long FSSAPCounter = 0;
int listenForServer(char *fs)
{
  static int count = 0;
  int i;
  SAP *sap;
  time_t t = time(NULL);

  if (!SAPWatchDogInitialized) return 1;

  for (i=0; i<NUM_SAP_ECB; i++)
  {
    if (!sapECB[i]->ecb.inUseFlag)
    {
      sap = &sapECB[i]->sap;
      if (!strcmp(sap->ServerName,fs))
      {
        count++;
        FSSAPCounter++;
      }
      if (NGdebug > 2) printf("SAP: %s\n>",sap->ServerName);
      IPXListenForPacket((ECB *)sapECB[i]);
    }
  }
  if (count)
  {
    fsAlive = 1;
    fsLastSAP = t;
    count = 0;     /* reset it */
  }
  if (t > fsLastSAP + FIVEMINUTES) fsAlive = 0;
  return fsAlive;
}
void checkScreenForPanic(void)
{
  int i;
  static char screenbuf[800];
  if (NGdebug) printf("DOG: Checking TCPIP kernel\n>");
  gettext(1,21,80,25,screenbuf);
  for (i=0; i<sizeof(screenbuf); i++)
  {
    screenbuf[i] = screenbuf[2*i];
  }
  if (strstr(screenbuf,"tcpip panic")) F_boot();
  return;
}
int netWatchDogStep = 0;
void netWatchDog(void)
{
  static time_t interim = 0L;
  time_t t = time(NULL);

  switch (netWatchDogStep)
  {
    case 0: if (!listenForServer(controlFS)) netWatchDogStep = 2;
            else if (t > interim + 30) netWatchDogStep = 1;
            return;
    case 1: netWatchDogStep = DiskErrorCount > 5 ? 2 : 0;
            if (TCPloaded) checkScreenForPanic();
	    interim = t;
	    return;
    case 2: if (!listenForServer(controlFS)) return;
            netWatchDogStep++;
	    return;
    case 3: if (RebootOnConnectionFailure) F_boot();
            netWatchDogStep = 0;
            return;
  }
}
