#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#ifdef UNIX
#include <dlfcn.h>
#endif
#include "tine.h"
#include "threader.h"
#include "tbufsrv.h"

extern int gSystemInitialized;
int cycle_busy = FALSE;
unsigned int idCycleTimer = 0;
int srvTerminated = FALSE;
int userNameSet = FALSE;

int gUseWindowsTimer = FALSE;
int gWindowsTimerInUse = FALSE;
int gThreadTimerInUse = TRUE;

void krnlTmrTask(void)
{
  if (!gSystemInitialized) return;
  if (srvTerminated) return;
  if (cycle_busy) return;
  cycle_busy = TRUE;
  SystemCycle(FALSE);
  cycle_busy = FALSE;
}

void krnlInitTask(int isServer)
{
  if (isServer) SystemInit(FALSE);
  gSystemInitialized = TRUE;
  MaxPollingRate = MinPollingRate = 20;
}

THREAD_TYPE krnlTmrThread(THREAD_PARAM lpvThreadParam)
{
  lpvThreadParam = lpvThreadParam;
  UseMultiThreadedCycler(TRUE);
  while (!srvTerminated)
  {
    krnlTmrTask();
  }
  return 0;
}
#if defined(UNIX)
int WaitForMutex(pthread_mutex_t *mx,int to);

pthread_attr_t gKrnlThreadAttr, *gPtrKrnlThreadAttr = &gKrnlThreadAttr;
pthread_mutex_t krnlThreadMutex = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t *hKrnlThreadMutex = &krnlThreadMutex;
int krnlCreateThread(void)
{
  int cc;
  pthread_t tid;

  if ((cc=pthread_mutex_init(hKrnlThreadMutex,NULL)) != 0)
  {
    feclog("Cannot create Tine Kernel Mutex: error %d",cc);
    return 0;
  }
  if ((cc=pthread_mutex_lock(hKrnlThreadMutex)) != 0)
  {
    feclog("Cannot lock Tine Kernel Mutex: error %d",cc);
    return 0;
  }
  pthread_attr_init(gPtrKrnlThreadAttr);
# ifdef FORCE_PTHREAD_SCOPE_SYSTEM
  if ((cc=pthread_attr_setscope(gPtrKrnlThreadAttr,PTHREAD_SCOPE_SYSTEM)) != 0) 
  {
    feclog("Cannot set thread scope !\n");
  }
# endif
  cc = pthread_create(&tid,gPtrKrnlThreadAttr,krnlTmrThread,NULL);
  feclog("Create Kernel Thread : %s",erlst[cc]);
  return cc ? 0 : (int)tid;
}

void TineStartCycler(void)
{
  static int hasStarted = FALSE;
  if (hasStarted) return;
  hasStarted = TRUE;
  krnlCreateThread();
  krnlInitTask(FALSE);
  return;
}
__attribute__((destructor)) void TineStopCycler(void)
{
  srvTerminated = TRUE;
  millisleep(20);
}
#endif /* unix */
