#ifndef TBUFSRV_H_
#define TBUFSRV_H_

#include "errors.h"
#include "servdef.h"
#include "rpctypes.h"
#include "toolkit.h"
#include "listener.h"

#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#ifdef TBUFSRVDLL_EXPORTS
# define EXPORT_B __declspec(dllexport) 
#endif 
#ifdef TBUFSRVDLL_IMPORTS
# define EXPORT_B __declspec(dllimport) 
#endif
#ifndef EXPORT_B
# define EXPORT_B 
#endif

EXPORT_B int AttachServer(char *srvExportName,char *srvEQPName,int ndevices);
EXPORT_B int AttachServerEx(char *srvExportName,char *srvEQPName,int ndevices,void (*tmr)(void),int tmrInterval);
EXPORT_B void runServer(void);
EXPORT_B int pushBufferedData(char *prpName,char *devName,BYTE *prpData,long prpSiz,int prpSchedule);
EXPORT_B int pullBufferedData(char *prpName,char *devName,BYTE *prpData,long prpSiz);
EXPORT_B int hasInputChanged(char *prpName);
EXPORT_B int RegisterServerCallback(char *prpName, int (*cb)(void));
EXPORT_B int GetInputDeviceNumber(void);
EXPORT_B int RegisterServerNotifierEx(char *prpName, void (*nf)(int), int nid);
EXPORT_B int RegisterServerNotifier(char *prpName, void (*nf)(int));
EXPORT_B int GetRegisteredProperties(NAME32 *prps, short *nprps);
EXPORT_B void TerminateServer();
EXPORT_B int SetBufferedCompletion(int compCode);
EXPORT_B int RegisterBufferedProperty
(
  char *prpName, long prpInSiz, short prpInFmt, long prpOutSiz, short prpOutFmt,
  float prpMax, float prpMin, char *prpEgu,	short access, char *prpDsc
);
EXPORT_B int getNotifiedProperty(char *prpName);
EXPORT_B int getNotifiedPropertyAndDevice(char *prpName,char *devName);

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* TBUFSRV_H_ */
