#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#include "tine.h"
#include "tbufsrv.h"

// this is legacy: remove this when tinecln32.dll is no longer in play !
extern __declspec(dllimport) short SetUserName(char *uname);

extern int gSystemInitialized;
extern int gNumDevices;
extern char gEqpName[16];

__declspec(dllexport) short PASCAL SetBufferedCompletionA(int compCode)
{
  return (short)SetBufferedCompletion(compCode);
}
__declspec(dllexport) short PASCAL AttachServerA(char *srvExportName,char *srvEQPName,int ndevices) 
{
  return AttachServer(srvExportName,srvEQPName,ndevices);
}
__declspec(dllexport) short PASCAL AttachDatabaseA()
{
  return AttachServer(NULL,NULL,0);
}
// TODO:  shouldn't this pass the eqm param ?
__declspec(dllexport) short PASCAL RegisterDeviceNameA(char *devName, short devNumber) 
{
  return (short)RegisterDeviceName(gEqpName,devName,devNumber);
}
__declspec(dllexport) short PASCAL GetRegisteredPropertiesA(NAME32 *prps, short *nprps)
{
  return (short)GetRegisteredProperties(prps,nprps);
}
// TODO: move this to the general lib; parse the desc for atype; pass the eqm param?
__declspec(dllexport) short PASCAL RegisterBufferedPropertyA
(
  char *prpName, long prpInSiz, short prpInFmt, long prpOutSiz, short prpOutFmt,
  float prpMax, float prpMin, char *prpEgu,	short access, char *prpDsc
) 
{
  return (int)RegisterBufferedProperty(prpName,prpInSiz,prpInFmt,prpOutSiz,prpOutFmt,prpMax,prpMin,prpEgu,access,prpDsc);
}
__declspec(dllexport) short PASCAL pushBufferedDataA(char *prpName,char *devName,BYTE *prpData,long prpSiz,int prpSchedule)
{
  return (short)pushBufferedData(prpName,devName,prpData,prpSiz,prpSchedule);
}
__declspec(dllexport) short PASCAL pullBufferedDataA(char *prpName,char *devName,BYTE *prpData,long prpSiz)
{
  return (short)pullBufferedData(prpName,devName,prpData,prpSiz);
}
__declspec(dllexport) short PASCAL hasInputChangedA(char *prpName)
{
  return (short)hasInputChanged(prpName);
}
__declspec(dllexport) short PASCAL getNotifiedPropertyA(char *prpName)
{
  return (short) getNotifiedProperty(prpName);
}
__declspec(dllexport) short PASCAL getNotifiedPropertyAndDeviceA(char *prpName,char *devName)
{
  return (short) getNotifiedPropertyAndDevice(prpName,devName);
}
__declspec(dllexport) short PASCAL GetInputDeviceNumberA(void)
{
  return (short)GetInputDeviceNumber();
}
__declspec(dllexport) short PASCAL RegisterServerCallbackA(char *prpName, int (*cb)(void))
{
  return (short)RegisterServerCallback(prpName,cb);
}
__declspec(dllexport) short PASCAL RegisterServerNotifierA(char *prpName, void (*nf)(int))
{
  return (short)RegisterServerNotifier(prpName,nf);
}
__declspec(dllexport) short PASCAL RegisterServerNotifierExA(char *prpName, void (*nf)(int), int nid)
{
  return (short)RegisterServerNotifierEx(prpName,nf,nid);
}

int SystemInitialized = FALSE;
int cycle_busy = FALSE;
unsigned int idCycleTimer = 0;
int srvTerminated = FALSE;
int userNameSet = FALSE;

int gUseWindowsTimer = FALSE;
int gWindowsTimerInUse = FALSE;
int gThreadTimerInUse = TRUE;

void srvTmrTask(void)
{
  if (!gSystemInitialized) return;
  if (srvTerminated) return;
  if (cycle_busy) return;
  cycle_busy = TRUE;
  SystemCycle(FALSE);
  cycle_busy = FALSE;
  if (!userNameSet)
  { //this is legacy: remove this when tinecln32.dll is no longer in play !
    if (strnicmp(gFecName,"*unknown*",16))
    {
      SetUserName(gFecName);
    }
    userNameSet = TRUE;
  }
}

VOID CALLBACK srvTimerProc(
  HWND hwnd,         // handle to window
  UINT uMsg,         // WM_TIMER message
  UINT_PTR idEvent,  // timer identifier
  DWORD dwTime       // current system time
)
{
  static int counter = 0;
  srvTmrTask();
  if (!gWindowsTimerInUse && counter++ > 5)
  {
    gWindowsTimerInUse = TRUE;
    gThreadTimerInUse = FALSE;
    feclog("using Windows Timer");
  }
}

#define THREAD_TYPE DWORD WINAPI 
#define THREAD_PARAM LPVOID

DWORD dwTmrThreadId;
HANDLE hTmrThread = 0;
THREAD_TYPE tmrTaskThread(THREAD_PARAM lpvThreadParam)
{
  static int counter = 0;
  static int logged = FALSE;
  feclog("timer thread starting");
  while (!srvTerminated && gThreadTimerInUse)
  {
    if (counter > 99) 
    {
      srvTmrTask();
      if (!logged) 
      { 
        KillTimer(NULL,idCycleTimer);
        feclog("using Thread Timer"); 
        logged = TRUE; 
        UseMultiThreadedCycler(TRUE);
      }
    }
    millisleep(10);
    if (counter < 100) counter++;
  }
  feclog("timer thread terminating");
  return 0;
}
HANDLE tmrCreateThread(void)
{
  return CreateThread(NULL,0,tmrTaskThread,0,0,&dwTmrThreadId);
}
extern int gTerminateServer;
void TineStartCycler(void)
{
  static int started = FALSE;
  if (started) return;
  started = TRUE;
  feclog("start timer");
  idCycleTimer = SetTimer(NULL,0,10,(TIMERPROC)srvTimerProc);
  hTmrThread = tmrCreateThread();
  millisleep(10);
}
void myKillTimer(void)
{
  feclog("kill timer");
  srvTerminated = TRUE;
  KillTimer(NULL,idCycleTimer);
}

void myStopServer(void)
{
  static int done = 0;

  if (done) return;
  srvTerminated = TRUE;
  myKillTimer();
  millisleep(20);
  /* a LabView restart doesn't unload the library ! */
  FreeEQPModules();
  gSystemInitialized = FALSE;
  //feclog("free system resources");
  //SystemFreeResources(FALSE);
  done = TRUE;
}

BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      TineStartCycler();
      gSystemInitialized = TRUE;
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      myStopServer();
      break;
  }
  return (TRUE);
}
