#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#include "errors.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
int tdevs(char *dev);
int tdevlist(char *dev);

char *usageTxt[] = {
  "\nRetrieves a list of registered devices for the given device server\n",
  "tdevlist <device server>",
  "e.g. tdevlist /HERA/HEPBLM",
  "\nSee also: 'tservers', 'tproplist' for retrieving information",
};

#define nUsageLines sizeof(usageTxt)/sizeof(char *)

int main(int argc, char *argv[])
{
  int i, cc;
  if (argc < 2) 
  {
    for (i=0; i<nUsageLines; i++)
    {
      printf(i == 1 ? "Usage : " : "        ");
      printf("%s\n",usageTxt[i]);
    }
    printf("\n");
    exit(1);
  }
  MaxNumConnections = 3;
  ListenForGlobals = ListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 200;
  nofeclog = TRUE;
  printf("\n");
  if ((cc=tdevlist(argv[1])) != 0)
    printf("error : %s\n",erlst[cc]);
  printf("\n");
  return cc;
}
