#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "srvip.h"
#include "servdef.h"
#include "rpctypes.h"
#include "errors.h"

extern int NGdebug;
extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
extern int defaultClientTimeout;
int tgetEx(char *dev,char *prp,int fmt, int siz);
int tgetFromRepeater(char *dev,char *prp,int fmt_,int siz_);


char *usageTxt[] = {
  "\nSynchronous call: gets the specified TINE device server property\n",
  "tget <device name> <property> [<size> <format>]",
  "e.g. tget /HERA/HEPBLM/WL105K1 AVELOSS",
  "or   tget /HERA/HEPBLM/WL105K1 AVELOSS 300 float",
  "\nUse quotes \"\" around device names with spaces",
  "e.g. tget \"/HERA/HEPBPM/WL197 MX\" ORBIT.X",
  "\nIf you regularly call 'tget' inside a script,\nplease make use of a 'trepeater' daemon!",
  "\nSee also: 'tmonitor', 'tsend' for sending and receiving data",
};

#define nUsageLines sizeof(usageTxt)/sizeof(char *)

int main(int argc, char *argv[])
{
  int i, cc;
  int siz = 0, fmt = CF_DEFAULT;
  if (argc < 3) 
  {
    for (i=0; i<nUsageLines; i++)
    {
      printf(i == 1 ? "Usage : " : "        ");
      printf("%s\n",usageTxt[i]);
    }
    printf("\n");
    exit(1);
  }
  MaxNumConnections = 3;
  ListenForGlobals = ListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 50;
  defaultClientTimeout = 50;
  nofeclog = TRUE;
  if (argc == 6)
  {
    NGdebug = atoi(argv[5]);
  }
  if (argc == 5)
  {
    siz = atoi(argv[3]);
    fmt = ftoi(argv[4]);
  }
  if (argc == 4)
  {
    NGdebug = atoi(argv[3]);
  }
  if ((cc=tgetFromRepeater(argv[1],argv[2],fmt,siz)) != 0 &&
      (cc=tgetEx(argv[1],argv[2],fmt,siz)) != 0)
     printf("error : %s\n",erlst[cc]);
  
  printf("\n");
  return cc;
}
