#include "cprolog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#include "tine.h"
#include "shmalloc.h"

unsigned int idCycleTimer = 0;
int cycleTerminated = FALSE;
int gSystemDelay = 20;

VOID CALLBACK srvTimerProc(
  HWND hwnd,         // handle to window
  UINT uMsg,         // WM_TIMER message
  UINT_PTR idEvent,  // timer identifier
  DWORD dwTime       // current system time
)
{
  static int cycle_busy = FALSE;
  if (cycleTerminated) return;
  if (cycle_busy) return;
  cycle_busy = TRUE;
  SystemCycle(FALSE);
  cycle_busy = FALSE;
}

EXPORT void SystemSetCycleTimer(void)
{
  idCycleTimer = SetTimer(NULL,0,gSystemDelay,(TIMERPROC)srvTimerProc);
  if (idCycleTimer == 0) 
  {
    feclog("failed to create cycle timer : %d",GetLastError());
  }
}
EXPORT void SystemKillCycleTimer(void)
{
  if (cycleTerminated) return;
  cycleTerminated = TRUE;
  KillTimer(NULL,idCycleTimer);
}
EXPORT int SetSystemDelay(int msecs)
{
  if (msecs >= 10) gSystemDelay = msecs;
  if (gSystemDelay < MaxPollingRate)
  {
    MaxPollingRate = MinPollingRate = gSystemDelay;
  }
  return gSystemDelay;
}
void DoEvents(void)
{
  MSG msg;
  while (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
}
BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      hParent = hInstDll;
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      DestroyShmWindow();
      break;
  }
  return (TRUE);
}
