# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI,OSF CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.4 CC = CC         CCL = CC         LM = -lsocket -lnsl

CFLAGS          = 
CPU             = MC68LC040
TOOL            = gnu
CC              =  cc68k -c -I $(WIND_BASE)/target/h -nostdinc -DCPU=MC68040 -m68040 -fno-builtin -O


#include $(WIND_BASE)/target/h/make/defs.bsp
#include $(WIND_BASE)/target/h/make/make.$(CPU)$(TOOL)
#include $(WIND_BASE)/target/h/make/defs.$(WIND_HOST_TYPE)


CCL = ld68k
LM = 

tineLib.o: server.o srvip.o srvdbase.o srvquery.o history.o toolkit.o client.o clnip.o iplib.o dblib.o database.o err_list.o swaplib.o almsrv.o syslib.o 
	${CCL} -o tineLib.o -r server.o srvip.o srvdbase.o srvquery.o history.o toolkit.o client.o clnip.o iplib.o dblib.o database.o err_list.o swaplib.o almsrv.o syslib.o ${LM}

rpcserv.o: rpcserv.c servdef.h prolog.h errors.h project.def
	${CC} $(CFLAGS) rpcserv.c

server.o:  server.c servdef.h prolog.h errors.h brdcast.h swaplib.h project.def
	${CC} $(CFLAGS) server.c

srvip.o: srvip.c servdef.h prolog.h srvip.h errors.h project.def
	${CC} $(CFLAGS) srvip.c

srvdbase.o: srvdbase.c database.h servdef.h prolog.h srvip.h errors.h project.def
	${CC} $(CFLAGS) srvdbase.c

srvquery.o: srvquery.c database.h servdef.h prolog.h history.h srvip.h errors.h project.def
	${CC} $(CFLAGS) srvquery.c

history.o: history.c history.h servdef.h prolog.h srvip.h errors.h project.def
	${CC} $(CFLAGS) history.c

toolkit.o: toolkit.c toolkit.h servdef.h prolog.h srvip.h errors.h project.def
	${CC} $(CFLAGS) toolkit.c

client.o: client.c prolog.h cprolog.h servdef.h errors.h swaplib.h rpctypes.h brdcast.h project.def
	${CC} $(CFLAGS) client.c

clnip.o: clnip.c prolog.h cprolog.h servdef.h errors.h swaplib.h rpctypes.h brdcast.h project.def
	${CC} $(CFLAGS) clnip.c

iplib.o: iplib.c servdef.h prolog.h srvip.h errors.h project.def 
	${CC} $(CFLAGS) iplib.c

dblib.o:  dblib.c database.h errors.h prolog.h project.def
	${CC} $(CFLAGS) dblib.c

database.o: database.c prolog.h cprolog.h database.h servdef.h errors.h project.def
	${CC} $(CFLAGS) database.c

almsrv.o:  almsrv.c almsrv.h database.h errors.h prolog.h project.def
	${CC} $(CFLAGS) almsrv.c

err_list.o: err_list.c errors.h project.def
	${CC} $(CFLAGS) err_list.c

swaplib.o: swaplib.c swaplib.h prolog.h servdef.h errors.h project.def
	${CC} $(CFLAGS) swaplib.c 

syslib.o: syslib.c prolog.h servdef.h project.def
	${CC} $(CFLAGS) syslib.c

clean:
	rm *.o
