#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include "servdef.h"
#include "rpctypes.h"
#include "database.h"
#include "toolkit.h"

extern int rpPollingRate;
extern int gTruncateDeviceNames;
int rpPreSystemInit(char *tgtContext,char *tgtServer);
int rpPostSystemInit(char *tgtContext,char *tgtServer);
int lsnPreSystemInit(void);
int lsnPostSystemInit(void);
int main(int argc, char *argv[])
{
  int cc, useStandardRepeater = FALSE;
  char cntxt[32],devsrv[32];
  switch (argc)
  {           
    case 5:
      gTruncateDeviceNames = atoi(argv[4]);
    case 4:
      rpPollingRate = atoi(argv[3]);
    case 3:   
      strncpy(cntxt,argv[1],16);
      strncpy(devsrv,argv[2],16);
      break;
    case 1:
      useStandardRepeater = TRUE;
      break;
    default:
      printf("Usage: tineRepeater <context> <device server>\n");
      printf("e.g.\n\ttineRepeater HERA HEEBLM\n\n");
      exit(1);
  }
  printf("Server running (debug level %d)\n",NGdebug);

  MaxRPCTransportSize = 1024*64*16;
  FeclogDepth = 500;
# ifdef MULTITHREADED
  useMultiThreadedEquipmentFunctions = FALSE;
  useMultiThreadedBackgroundTasks = FALSE;
# endif
  if (useStandardRepeater) /* local piped server */
    lsnPreSystemInit();
  else                     /* repeat the targetted server */
    rpPreSystemInit(cntxt,devsrv);

  if ((cc=SystemInit(TRUE)) != 0) { printf("init error: %s\n",erlst[cc]); exit(1); }

  if (useStandardRepeater) /* local piped server */
  {
    lsnPostSystemInit();
    FecNameRegistered = FALSE;
    ExportsRegistered = TRUE; /* make sure I don't plug-and-play */
  }
  else                     /* repeat the targetted server */
    rpPostSystemInit(cntxt,devsrv);

  for (;;)
  {
    SystemCycle(TRUE);
  }
  return 0;
}
