#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#include "errors.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
int tinfo(char *dev,char *prp);
char *usageTxt[] = {
  "\nRetreives information about the specified device server and property.\n",
  "Usage : tinfo <device name> <property>\n",
  "        e.g. tinfo /HERA/HEPBPM ORBIT.X",
  "\nSee also: 'tservers', 'tproplist', 'tdevlist' for retrieving information",
};

#define nUsageLines sizeof(usageTxt)/sizeof(char *)

int main(int argc, char *argv[])
{
  int i, cc;
  if (argc < 3) 
  {
    for (i=0; i<nUsageLines; i++)
    {
      printf("%s\n",usageTxt[i]);
    }
    printf("\n");
    exit(1);
  }
  MaxNumConnections = 3;
  ListenForGlobals = ListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 50;
  nofeclog = TRUE;
  printf("\n");
  if ((cc=tinfo(argv[1],argv[2])) != 0)
    printf("error : %s\n",erlst[cc]);
  printf("\n");
  return cc;
}
