#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#include "errors.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
int tmonitor(char *dev,char *prp);
int tmonitorEx(char *dev,char *prp,int fmt,int siz);

char *usageTxt[] = {
  "\nAsynchronous call : Monitors the specified TINE device server property\n",
  "tmonitor <device name> <property> [<size> <format>]",
  "e.g. tmonitor /HERA/HEPBLM/WL105K1 AVELOSS",
  "or   tmonitor /HERA/HEPBLM/WL105K1 AVELOSS 300 float",
  "\nUse quotes \"\" around device names with spaces",
  "e.g. tmonitor \"/HERA/HEPBPM/WL197 MX\" ORBIT.X",
  "\nSee also: 'tget', 'tsend' for sending and receiving data",
};

#define nUsageLines sizeof(usageTxt)/sizeof(char *)


int main(int argc, char *argv[])
{
  int i, cc;
  int siz = 0, fmt = CF_NULL;
  if (argc < 3) 
  {
    for (i=0; i<nUsageLines; i++)
    {
      printf(i == 1 ? "Usage : " : "        ");
      printf("%s\n",usageTxt[i]);
    }
    printf("\n");
    exit(1);
  }
  MaxNumConnections = 3;
  ListenForGlobals = ListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 200;
  nofeclog = TRUE;
  if (argc == 5)
  {
    siz = atoi(argv[3]);
    fmt = ftoi(argv[4]);
  }
  if ((cc=tmonitorEx(argv[1],argv[2],fmt,siz)) != 0) printf("error : %s\n",erlst[cc]);
  for (;;) SystemCycle(TRUE);
  return cc;
}
