#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#include "errors.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
int tprops(char *dev);
int tproplist(char *dev);

char *usageTxt[] = {
  "\nRetrieves a list of registered properties for the given device server\n",
  "tproplist <device server> or tproplist <device server>/<device name>",
  "e.g. tproplist /HERA/HEPBLM",
  "  or tproplist /HERA/HEPBLM/WL105K1",
  "\nIf you specify a specific device name and it contains blanks use \"\"",
  "e.g. tproplist \"/HERA/HEPBPM/WL197 MX\"",
  "\nSee also: 'tservers', 'tdevlist' for retrieving information",
};

#define nUsageLines sizeof(usageTxt)/sizeof(char *)

int main(int argc, char *argv[])
{
  int i,cc;
  if (argc < 2) 
  {
    for (i=0; i<nUsageLines; i++)
    {
      printf(i == 1 ? "Usage : " : "        ");
      printf("%s\n",usageTxt[i]);
    }
    printf("\n");
    exit(1);
  }
  MaxNumConnections = 3;
  ListenForGlobals = ListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 50;
  nofeclog = TRUE;
  printf("\n");
  if ((cc=tproplist(argv[1])) != 0)
    printf("error : %s\n",erlst[cc]);
  printf("\n");
  return cc;
}
