#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#include "errors.h"

/* 
   Note:  the binary executable for 'tput' cannot be called 'tput' due to a conflict on UNIX systems.
   Therefor it should be called tsend.exe or tsend 
*/
extern int NGdebug;
extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
extern int defaultClientTimeout;
int tput(char *dev,char *prp,char *datastr);

char *usageTxt[] = {
  "\nSynchronous call: sends the input data to the specified TINE device",
  "server and property.  Sets the WRITE access bit by default.\n",
  "A single string can be sent by enclosing the data in quotes \"\".",
  "A data array can be separated by blanks, commas, or semi-colons.",
  "A string data array will be sent as either NAME32 or NAME16 elements.",
  "Do not enclose string arrays with quotes!\n",
  "Usage : tsend <device name> <property> <data1> [<data2> <data3> ...]\n",
  "        e.g. tsend /HERA/HEPBLM/WL105K1 MODE 1",
  "        or   tsend /HERA/HEPBPM/WL105K1 MESSAGE \"hello\"",
  "\nUse quotes \"\" around device names with spaces\n",
  "        e.g. tsend \"/HERA/HEPBPM/WL197 MX\" MODE 1",
  "        or   tsend \"/HERA/HEPBPM/WL197 MX\" MESSAGE \"hello\"",
  "\nSee also: 'tmonitor', 'tget' for receiving data",
};

#define nUsageLines sizeof(usageTxt)/sizeof(char *)

int main(int argc, char *argv[])
{
  int i, len, cc;
  char *s, datastr[2048];
  int isText = FALSE;
  if (argc < 4) 
  {
    for (i=0; i<nUsageLines; i++)
    {
      printf("%s\n",usageTxt[i]);
    }
    printf("\n");
    exit(1);
  }
  if (argc == 4)
  {
    s = argv[3];
    len = strlen(s);
    for (i=0; i<len; i++) if (!isdigit(s[i])) break;
    if ((i < len) && strncmp(s,"0x",2) && strncmp(s,"0X",2))
    {
      isText = TRUE;
    }
  }
  MaxNumConnections = 3;
  ListenForGlobals = ListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 50;
  defaultClientTimeout = 50;
  nofeclog = TRUE;
  datastr[0] = 0;
  if (isText) strcat(datastr,"\"");
  for (i=3; i<argc; i++) 
  {
    strcat(datastr,argv[i]);
    if (i < argc - 1) strcat(datastr," ");
  }
  if (isText) strcat(datastr,"\"");
  switch ((cc=tput(argv[1],argv[2],datastr))) 
  {
    case 0:
      printf("success\n");
      break;
    default:
      printf("error  <%d> :%s\n",cc, RPCLastErrorString);
      break;
  }
  return cc;
}
