#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#include "errors.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
int tservers(char *context);
int tserversEx(char *cnt,char *sub);

char *usageTxt[] = {
  "\nRetrieves a list of registered servers for the given context and subsystem\n",
  "tservers <context> [<subsystem>]",
  "e.g. tservers HERA",
  "  or tservers HERA MAG",
  "\nSee also: 'tproplist', 'tdevlist' for retrieving information",
};

#define nUsageLines sizeof(usageTxt)/sizeof(char *)

int main(int argc, char *argv[])
{
  int i,cc;
  MaxNumConnections = 3;
  ListenForGlobals = ListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 200;
  nofeclog = TRUE;
  printf("\n");
  switch (argc)
  {
    case 2:
      if ((cc=tservers(argv[1])) != 0) printf("error : %s\n",erlst[cc]);
      break;
    case 3:
      if ((cc=tserversEx(argv[1],argv[2])) != 0) printf("error : %s\n",erlst[cc]);
      break;
    default:
      for (i=0; i<nUsageLines; i++)
      {
        printf(i == 1 ? "Usage : " : "        ");
        printf("%s\n",usageTxt[i]);
      }
      printf("\n");
      exit(1);
  }
  printf("\n");
  return cc;
}
