#include "prolog.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <stddef.h>
#include "servdef.h"
#include "database.h"
#include "errors.h"
#include "vxwcmd.h"

int tget_help(void)
{
  ttyoutput("Currently available commands:\n>");
  if (NrOfEqpTypes)
  {
    ttyoutput("\ttget_clients             - displays the current consumer list\n>");
    ttyoutput("\ttget_contracts           - displays the current contract list\n>");
    ttyoutput("\ttget_contract(#)         - displays contract Nr. <#> information\n>");
  }
  if (nglobals)
  {
    ttyoutput("\ttget_globals     - displays the current globals list\n>");
  }
  if (nConnectionTableEntries)
  {
    ttyoutput("\ttget_connections          - displays the current connection list\n>");
    ttyoutput("\ttget_connection(#)        - displays connection Nr. <#> information\n>");
  }
  ttyoutput("\ttget_time                 - displays local time\n>");
  ttyoutput("\ttget_version              - displays TINE version number\n>");
  ttyoutput("\ttget_users                - displays WRITE access user list\n>");
  ttyoutput("\ttget_nets                 - displays WRITE access net list\n>");
  ttyoutput("\ttget_stats                - displays operational statistics\n>");
  ttyoutput("\ttset_debug(0-4)           - sets debug level\n>");
  ttyoutput("\tthelp            - display this list\n>");
  return 0;
}
int tget_version(void) { return dumpVersion(); }
int tset_debug(int val)
{
  NGdebug = val;
  return 0;
}
int tget_users(void) { dumpRegisteredUsers(); return 0; }
int tget_globals(void) { dumpGlobals(); return 0; }
int tget_nets(void)
{
  dumpIPNets();
  return 0;
}
int tget_time(void) { return dumpServerTime(); }

int tget_clients(void) { return dumpConsumerList(); }
int tget_contract(int i) { dumpContractStats(i); return 0; }
int tget_contracts(void) { return dumpContractList(); }
int tget_connection(int i)
{
  dumpConnectionStats(i);
  return 0;
}
int tget_connections(void) { dumpConnectionList(); return 0; }
int tget_stats(void) { return dumpServerStats(); }
